package com.fossgalaxy.games.tbs.ai.strategicmcts;

import com.fossgalaxy.games.tbs.GameState;

/**
 * Before giving a state to a child - use policy on state and then calculate automatic actions
 *
 * Closed loop design for speed
 */
public class StrategicNode {

    private final StrategicNode parent;
    private StrategicNode[] children;
    private int childrenExpandedSoFar;
    private final int depth;
    private GameState state;
    private final StrategicMCTS mcts;

    public StrategicNode(StrategicMCTS mcts, GameState state) {
        this.mcts = mcts;
        this.state = new GameState(state);
        this.parent = null;
        this.depth = 0;
    }

    public StrategicNode(StrategicNode parent) {
        this.parent = parent;
        this.mcts = parent.mcts;
        this.depth = parent.depth + 1;
        this.state = new GameState(parent.state);
    }

    public StrategicNode select() {
        return null;
    }

    public StrategicNode expand() {
        return null;
    }

    public double rollout() {
        return 0.0;
    }


    public boolean isRoot() {
        return parent == null;
    }

    public boolean isFullyExpanded() {
        return (children != null) && children.length == childrenExpandedSoFar;
    }
}
