package com.fossgalaxy.games.tbs.editor;


import com.fossgalaxy.games.tbs.editor.EditorView.EditorModel;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.io.File;

public class SaveAction extends AbstractAction {
    private EditorModel model;

    public SaveAction(EditorModel model) {
        super("Save");
        this.model = model;
    }

    @Override
    public void actionPerformed(ActionEvent actionEvent) {

        String filePath = model.getDefaultFilePath();
        if (filePath == null) {
            filePath = System.getProperty("user.dir");
        }

        JFileChooser fc = new JFileChooser(filePath);

        JsonFileFilter filer = new JsonFileFilter();
        fc.addChoosableFileFilter(filer);
        fc.setFileFilter(filer);

        int retVal = fc.showSaveDialog(null);

        if (retVal == JFileChooser.APPROVE_OPTION) {

            File f = fc.getSelectedFile();
            model.setDefaultFilePath(f.getParent());

            Builder.saveMapData(fc.getSelectedFile(), model.getDef());
        }
    }
}
